;Limitations: always uses exploding dice ala Savage Worlds; if multiple dice are called for, it only shows the total, not the in

#include <GUIConstants.au3>
#include <Array.au3>

; Define the GUI
$GUIHandle= GUICreate("Odds and Evens", 574, 469, -1, -1)
	
	$Input= GUICtrlCreateInput("",10, 10, 269, 20)
	$DoIt= GUICtrlCreateButton("Do It!", 10, 40, 209, 25)
	$ClrWindow= GUICtrlCreateButton("Clear", 229, 40, 50, 25)
	$OutputWindow= GUICtrlCreateEdit("", 10, 75, 269, 210)

GuiSetState ()

; Generates a random number between 1 and 1 million and uses it to seed the random number generator
$RandomSeed=random(1,1000000,1)
SRandom($RandomSeed) 

; Run the GUI until the dialog is closed
While 1
    $msg = GUIGetMsg()
	Select
		Case $msg = $DoIt
			parsemsg(GUICtrlRead($Input))
		Case $msg = $ClrWindow
			GUICtrlSetData($OutputWindow, "")
	EndSelect
	If $msg = $GUI_EVENT_CLOSE Then ExitLoop
WEnd

Func parsemsg($DiceString)
	If StringInStr($DiceString, "+") = 0 Then ;This is for single die descriptors (i.e. 4d6 or d6w, not expressions like 4d6+4d4w+d8)
		Dim $DiceArray[2]
		$DiceArray[0]= 1				; Not really needed, kept it so that it would have the same structure as expressions
		$DiceArray[1]= $DiceString		; holds individual descriptors
		$DiceLength= StringLen($DiceArray[1])
		$DPosition= StringInStr($DiceArray[1], "d")
		$WPosition= StringInStr($DiceArray[1], "w")
		$OutString= ""
		If $DPosition = 1 Then ;Find out how many dice to roll, load into the $DieNum variable
			$DieNum = 1
		Else
			$DieNum = Int(StringLeft($DiceArray[1],$DPosition-1)) ;pull the left most numbers from the string up until the "d" then assign them to $DieNum
		EndIf
		If $WPosition= 0 Then		; load the type of dice into $NumSides, there are different methods if a wild die is present
			$NumCharacters= $DiceLength-$DPosition
			$NumSides= Int(StringRight($DiceArray[1], $NumCharacters))
		Else
			$NumCharacters= ($DiceLength-1)-$DPosition
			$NumSides= Int(StringMid($DiceArray[1], $DPosition+1, $NumCharacters))
			$WildRoll= RollDie(6, "Explode") ; get the wild die result if present and load it into $WildRoll
		EndIf
		$Total= 0
		For $i = 1 to $DieNum ; generate total for non-wild dice
			$NumGend= RollDie($NumSides, "Explode")
			$Total= $Total+$NumGend
		Next
		If $WPosition= 0 Then ;build the output string, different for wild and non-wild having rolls
			$OutString= $Total & " (" & $DiceArray[1] & ")"
		Else
			$OutString= $Total & "," & $WildRoll & "w, (" & $DiceArray[1] & ")"
		EndIf
		GUICtrlSetData($OutputWindow, $OutString & @CRLF & GUICtrlRead($OutputWindow))
	Else ; This case is for expressions
		$DiceArray= StringSplit($DiceString, "+")
		$AbsTotal = 0
		$WildTotal = 0
		$FinalOutString = ""
		For $j = 1 to $DiceArray[0] ;StringSplit returns an array of string split by whatever delimiter you give it. In element 0([0]), it list the number of strings returned.
			$DiceLength= StringLen($DiceArray[$j])
			$DPosition= StringInStr($DiceArray[$j], "d")
			$WPosition= StringInStr($DiceArray[$j], "w")
			$OutString= ""
			$WildRoll = 0
			$Total= 0
			If $DPosition = 1 Then ;Find out how many dice to roll, load into the $DieNum variable
				$DieNum = 1
			Else
				$DieNum = Int(StringLeft($DiceArray[$j],$DPosition-1)) ;pull the left most numbers from the string up until the "d" then assign them to $DieNum
			EndIf
			If $WPosition= 0 Then		; load the type of dice into $NumSides, there are different methods if a wild die is present
				$NumCharacters= $DiceLength-$DPosition
				$NumSides= Int(StringRight($DiceArray[$j], $NumCharacters))
			Else
				$NumCharacters= ($DiceLength-1)-$DPosition
				$NumSides= Int(StringMid($DiceArray[$j], $DPosition+1, $NumCharacters))
				$WildRoll= RollDie(6, "Explode") ; get the wild die result if present and load it into $WildRoll
			EndIf
			For $i = 1 to $DieNum ; generate total for non-wild dice
				$NumGend= RollDie($NumSides, "Explode")
				$Total= $Total+$NumGend
			Next
			If $WPosition= 0 Then ;build the output string, different for wild and non-wild having rolls
				$OutString= $Total
			Else
				$OutString= $Total & "," & $WildRoll & "w"
			EndIf
			$WildTotal = $WildTotal + $WildRoll
			$AbsTotal= $AbsTotal+$Total
			If $WildTotal = 0 Then
				$WildOut = ""
			Else
				$WildOut = ", " & $WildTotal & "w"
			EndIf
			If $j= $DiceArray[0] Then ;put the finishing touches on the output string if this is the last pass through the loop
				$FinalOutString= $FinalOutString & $OutString & " (Total: " & $AbsTotal & $WildOut & " | " & $DiceString & ")"
			Else
				$FinalOutString= $FinalOutString & $OutString & " + "
			EndIf
		Next
		GUICtrlSetData($OutputWindow, $FinalOutString & @CRLF & GUICtrlRead($OutputWindow))
	EndIf
EndFunc

Func RollDie($Sides, $Type)
	Select
		Case $Type= "norm" ; A normal dice roll
			$Result = Random(1, $Sides, 1)
		Case $Type= "Explode" ; Exploding Dice, ala Savage Worlds
			$Again= False
			$Result= 0
			Do
				$Roll= Random(1, $Sides, 1)
				$Result= $Result+$Roll
			Until $Roll<$Sides
	EndSelect
	Return $Result
EndFunc
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			